//+------------------------------------------------------------------+
//|                                                        HH_LL.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_color5 Lime
#property indicator_color6 Red
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT


extern int MaPeriod=1;
extern int MaMethod=1;
extern int MaPrice =0;

extern int HHLLPeriod1=36;
extern int HHLLPeriod2=72;
extern int HHLLPeriod3=154;


double MA[];
double HH_MA[];
double LL_MA[];
double HH_MA2[];
double LL_MA2[];
double HH_MA3[];
double LL_MA3[];
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,HH_MA);
   SetIndexBuffer(1,LL_MA);
   SetIndexBuffer(2,HH_MA2);
   SetIndexBuffer(3,LL_MA2);
   SetIndexBuffer(4,HH_MA3);
   SetIndexBuffer(5,LL_MA3);
   SetIndexBuffer(6,MA);
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         int maxi  = MathMax(MathMax(HHLLPeriod1,HHLLPeriod2),HHLLPeriod3);

    
   for (int i=limit; i>=0; i--)
   {
      MA[i]     = iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i);
      HH_MA[i]  = MA[i];     
      LL_MA[i]  = MA[i];     
      HH_MA2[i] = MA[i];     
      LL_MA2[i] = MA[i];     
      HH_MA3[i] = MA[i];     
      LL_MA3[i] = MA[i];     
      for (int k=1; k<maxi; k++)
      {
         if (k<HHLLPeriod1)
         {
            HH_MA[i] = MathMax(MA[i+k],HH_MA[i]);
            LL_MA[i] = MathMin(MA[i+k],LL_MA[i]);
         }            
         if (k<HHLLPeriod2)
         {
            HH_MA2[i] = MathMax(MA[i+k],HH_MA2[i]);
            LL_MA2[i] = MathMin(MA[i+k],LL_MA2[i]);
         }
         if (k<HHLLPeriod3)
         {
            HH_MA3[i] = MathMax(MA[i+k],HH_MA3[i]);
            LL_MA3[i] = MathMin(MA[i+k],LL_MA3[i]);
         }
      }         
   }
   return(0);
}